module offset_angle_mod
  use sep_mod
  use odcig_mod
  use adcig_mod
  implicit none
  integer,private ::  n(4),nth
        integer, parameter, private:: dbl=selected_int_kind(12)
  logical, private :: push
  real,private    :: o(4),d(4),amax,eps
  type(paxis),private :: az,ahx,ahy,aax,aay

contains


  subroutine init_angle(n_,o_,d_,amax_,eps_,push_)
    integer :: n_(4)
    real    :: o_(4)
    real    :: d_(4)
    real    :: amax_,eps_
    logical :: push_
    integer,external :: omp_get_num_threads
    n=n_; o=o_; d=d_; amax=amax_;
    nth=omp_get_num_threads()
  !  call odcig_fft_init(nth,(/n(1),n(2),1/))
    az%n=n(1); az%o=o(1); az%d=d(1)
    ahx%n=n(2); ahx%o=o(2); ahx%d=d(2)
    ahy%n=1; ahy%o=0.; ahy%d=1.
    aax%n=n(2); aay%n=1; aay%o=0; aay%d=1.
    if(ahx%o==0.) then
      aax%o=0.; aax%d=amax/aax%n
    else
      aax%o=-amax
      aax%d=2*amax/aax%n
    end if
    call adcig_shift_init(az,ahx,ahy)
    call odcig_shift_init(az,ahx,ahy)
    call odcig_fft_init(nth,(/n(1),n(2),1/))
    call adcig_fft_init(nth,(/n(1),n(2),1/))
    push=push_
    eps=eps_
  end subroutine

  subroutine to_offset(ang,off)
    real :: ang(:),off(:)
    integer ::ith,i1,i2,i3,i4

    integer(kind=dbl) :: i
    complex, allocatable :: cdata(:,:,:,:)
    integer, external :: omp_get_thread_num
    allocate(cdata(n(1),n(2),1,n(3)*n(4)))
    
        call odcig_off_init(nth,az,ahx,aax,eps,push)
    i=0
    do i4=1,n(4)
      do i3=1,n(3)
        do i2=1,n(2)
          do i1=1,n(1)
            i=i+1
            cdata(i1,i2,i3,i4)=cmplx(ang(i),0.)
          end do
        end do
      end do
    end do
  !  !$OMP PARALLEL DO private(i,ith)
    do i=1,n(3)*n(4)
      !ith=omp_get_thread_num()+1
      ith=1
      call odcig_f_fft(ith,i,cdata)
      call odcig_f_shift(i,cdata)
      call odcig_off_x(ith,i,cdata,az,ahx,aax,ahy)
      call odcig_i_shift(i,cdata)
      call odcig_i_fft(ith,i,cdata)
    end do
   ! !$OMP END PARALLEL DO
    i=0
    do i4=1,n(4)
      do i3=1,n(3)
        do i2=1,n(2)
          do i1=1,n(1)
            i=i+1
            off(i)=real(cdata(n(1)+1-i1,i2,i3,i4))
          end do
        end do
      end do
    end do
    call odcig_off_close()
    deallocate(cdata)
  end subroutine

integer function offset_op(adj,add,ang,off)
   logical,intent(in) :: adj,add
    real :: off(:),ang(:)
   integer ::ith,i1,i2,i3,i4
   
    integer(kind=dbl) :: i
    complex, allocatable :: cdata(:,:,:,:)
    integer, external :: omp_get_thread_num
    allocate(cdata(n(1),n(2),1,n(3)*n(4)))
    
     offset_op=0;
    
     call odcig_off_init(nth,az,ahx,aax,eps,push)
     if(adj) then
        if(.not. add) ang=0;
        i=0
        do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
              i=i+1
               cdata(i1,i2,i3,i4)=cmplx(off(i),0.)
            end do
          end do
        end do
      end do
     else
       if(.not. add) off=0;
       i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               cdata(n(1)+1-i1,i2,i3,i4)=cmplx(ang(i),0.)
            end do
          end do
        end do
      end do
     end if

    do i=1,n(3)*n(4)
    
       if(.not. adj) then
         ith=1
               call odcig_i_fft(ith,i,cdata)
       call odcig_i_shift(i,cdata)
       call odcig_off_x_op(adj,ith,i,cdata,az,ahx,aax,ahy)
       call odcig_f_shift(i,cdata)
       call odcig_f_fft(ith,i,cdata)

      else
        ith=1
       call odcig_f_fft(ith,i,cdata)
       call odcig_f_shift(i,cdata)
       call odcig_off_x_op(adj,ith,i,cdata,az,ahx,aax,ahy)
       call odcig_i_shift(i,cdata)
       call odcig_i_fft(ith,i,cdata)
      


      end if

    end do
    
    if(.not. adj) then
            i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               off(i)=real(cdata(i1,i2,i3,i4))+off(i)
            end do
          end do
        end do
      end do
    else 
            i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               ang(i)=real(cdata(n(1)+1-i1,i2,i3,i4))+ang(i)
            end do
          end do
        end do
      end do    
      end if
    call odcig_off_close()
    deallocate(cdata)
    
    
    
  end function

integer function angle_op(adj,add,ang,off)
   logical,intent(in) :: adj,add
    real :: off(:),ang(:)
   integer ::ith,i1,i2,i3,i4
   
    integer(kind=dbl) :: i
    complex, allocatable :: cdata(:,:,:,:)
    integer, external :: omp_get_thread_num
    allocate(cdata(n(1),n(2),1,n(3)*n(4)))
    
     angle_op=0;
    
     call adcig_ang_init(nth,az,ahx,aax,eps,push)
     if(adj) then
        if(.not. add) ang=0;
        i=0
        do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
              i=i+1
               cdata(i1,i2,i3,i4)=cmplx(off(i),0.)
            end do
          end do
        end do
      end do
     else
       if(.not. add) off=0;
       i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               cdata(i1,i2,i3,i4)=cmplx(ang(i),0.)
            end do
          end do
        end do
      end do
     end if

    do i=1,n(3)*n(4)
    
       if(adj) then
         ith=1
        call adcig_f_fft(ith,i,cdata)
        call adcig_f_shift(i,cdata)
        call adcig_ang_x_op(adj,ith,i,cdata,az,ahx,aax,ahy)
        call adcig_i_shift(i,cdata)
        call adcig_i_fft(ith,i,cdata)
      else
        ith=1

        call adcig_i_fft(ith,i,cdata)

        call adcig_i_shift(i,cdata)

        call adcig_ang_x_op(adj,ith,i,cdata,az,ahx,aax,ahy)

        call adcig_f_shift(i,cdata)

        call adcig_f_fft(ith,i,cdata)

      end if

    end do
    
    if(.not. adj) then
            i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               off(i)=real(cdata(i1,i2,i3,i4))
            end do
          end do
        end do
      end do
    else 
            i=0;
             do i4=1,n(4)*n(3)
         do i3=1,1
          do i2=1,n(2)
            do i1=1,n(1)
               i=i+1
               ang(i)=real(cdata(i1,i2,i3,i4))
            end do
          end do
        end do
      end do    
      end if
    call adcig_ang_close()
    deallocate(cdata)
    
    
    
    
  end function

  subroutine to_angle(off,ang)
    real :: off(:),ang(:)
   integer ::ith,i1,i2,i3,i4
   
    integer(kind=dbl) :: i
    complex, allocatable :: cdata(:,:,:,:)
    integer, external :: omp_get_thread_num
    allocate(cdata(n(1),n(2),1,n(3)*n(4)))
    
    
    write(0,*) "IN TO ANGLE"
     call adcig_ang_init(nth,az,ahx,aax,eps,push)

    i=0
    do i4=1,n(4)*n(3)
      do i3=1,1
        do i2=1,n(2)
          do i1=1,n(1)
            i=i+1
            cdata(i1,i2,i3,i4)=cmplx(off(i),0.)
          end do
        end do
      end do
    end do
    write(0,*) "XXX"
   ! !$OMP PARALLEL DO private(i,ith)
    do i=1,n(3)*n(4)
      ith=omp_get_thread_num()+1
       ith=1
      call adcig_f_fft(ith,i,cdata)
      call adcig_f_shift(i,cdata)
     !  write(0,*) "dksdfls 2",i,size(cdata,4),n(3)*n(4)
      call adcig_ang_x(ith,i,cdata,az,ahx,aax,ahy)
      call adcig_i_shift(i,cdata)
      call adcig_i_fft(ith,i,cdata)

    end do
   ! !$OMP END PARALLEL DO
   write(0,*) "YYY"
        i=0
    do i4=1,n(4)*n(3)
      do i3=1,1
        do i2=1,n(2)
          do i1=1,n(1)
            i=i+1
            ang(i)=real(cdata(i1,i2,i3,i4))
          end do
        end do
      end do
    end do
    call adcig_ang_close()
    deallocate(cdata)
    write(0,*) "OUT ANGLE"
  end subroutine







end module
