program compress_test
use fft
use sep
use quantile_mod
use wavelet3_mod
integer :: n1,n2,n3,n4
real, allocatable:: in(:,:,:,:),out(:,:,:,:),m(:),d(:)
complex,allocatable :: cbuf(:,:,:,:),buf(:)
integer :: i1,i2,i3,i4
logical :: dofft
real :: pct,clip
integer :: iclip,ierr
real :: rgh0(9),sm0(7)

call sep_init()
call from_history("n1",n1)
call from_history("n2",n2)
call from_history("n3",n3)
call from_history("n4",n4)
allocate(in(n1,n2,n3,n4),out(n1,n2,n3,n4))
call from_param("pct",pct,5.)
call from_param("fft",dofft,.false.)
iclip=(1.-pct/100.)*real(n1*n2*n3*n4)
ierr=sreed("in",in,size(in)*4)
if(.not. dofft)then
  rgh0=(/.037828,-.023849,-.110624,.377402,.852699,.377402,-.110624,-.023849,.037828/)
  sm0=(/-.064539,-.040689,.418092,.788486,.418092,-.040689,-.064539/)
  call init_wavelet_transform(sm0,rgh0,n1,n2,n3,n4,4,2,1,1)
  allocate(m(n1*n2*n3*n4),d(n1*n3*n2*n4))
  d=reshape(in,(/n1*n2*n3*n4/))
  ierr=wavelet_transform_op(.true.,.false.,m,d)
  d=abs(m)
  ierr=srite("out",m,size(m)*4)
  clip=quantile(iclip,d)
  do i1=1,n1*n2*n3*n4
   if(abs(m(i1))< clip) m(i1)=0.
  end do
  ierr=srite("out",m,size(m)*4)
  ierr=wavelet_transform_op(.false.,.false.,m,d)
  out=reshape(d,(/n1,n2,n3,n4/))
else
  allocate(cbuf(n1,n2,n3,n4))
  cbuf=in
  allocate(buf(n1))
  do i4=1,n4
    do i3=1,n3
      do i2=1,n2
        buf=cbuf(:,i2,i3,i4)
	call ftu(.false.,buf)
        cbuf(:,i2,i3,i4)=buf
     end do
   end do
 end do
 deallocate(buf); allocate(buf(n2))
  do i4=1,n4
    do i3=1,n3
      do i1=1,n1
        buf=cbuf(i1,:,i3,i4)
	call ftu(.false.,buf)
        cbuf(i1,:,i3,i4)=buf
     end do
   end do
 end do
 deallocate(buf); allocate(buf(n3))
  do i4=1,n4
    do i2=1,n2
      do i1=1,n1
        buf=cbuf(i1,i2,:,i4)
	call ftu(.false.,buf)
        cbuf(i1,i2,:,i4)=buf
     end do
   end do
 end do
 deallocate(buf); allocate(buf(n4))
  do i3=1,n3
    do i2=1,n2
      do i1=1,n1
        buf=cbuf(i1,i2,i3,:)
	call ftu(.false.,buf)
        cbuf(i1,i2,i3,:)=buf
     end do
   end do
 end do
 allocate(m(size(cbuf)),d(size(cbuf)))
 m=reshape(cabs(cbuf),(/n1*n2*n3*n4/))
 d=m 
 ierr=srite("out",m,size(m)*4)
 clip=quantile(iclip,d)
write(0,*) "CHECK THE CLIP",clip
write(0,*) "SUM",sum(cbuf),sum(m)
ierr=0
 do i4=1,n4
  do i3=1,n3
    do i2=1,n2
      do i1=1,n1
       if( m(i1+i2*n1+i3+n1*n2+n1*n2*n3*i4)< clip) then
         cbuf(i1,i2,i3,i4)=0.
         m(i1+i2*n1+i3+n1*n2+n1*n2*n3*i4)=0
       else
ierr=ierr+1
!    write(0,*) "found large",i1,i2,i3,i4
       end if
      end do
    end do
  end do
end do
write(0,*) "SUM",sum(cbuf),sum(m)
write(0,*) "TOT",ierr
 ierr=srite("out",m,size(m)*4)
  deallocate(buf);allocate(buf(n1))
  do i4=1,n4
    do i3=1,n3
      do i2=1,n2
        buf=cbuf(:,i2,i3,i4)
	call ftu(.true.,buf)
        cbuf(:,i2,i3,i4)=buf
     end do
   end do
 end do
write(0,*) "SUM",sum(cbuf),sum(m)
 deallocate(buf); allocate(buf(n2))
  do i4=1,n4
    do i3=1,n3
      do i1=1,n1
        buf=cbuf(i1,:,i3,i4)
	call ftu(.true.,buf)
        cbuf(i1,:,i3,i4)=buf
     end do
   end do
 end do
write(0,*) "SUM",sum(cbuf),sum(m)
 deallocate(buf); allocate(buf(n3))
  do i4=1,n4
    do i2=1,n2
      do i1=1,n1
        buf=cbuf(i1,i2,:,i4)
	call ftu(.true.,buf)
        cbuf(i1,i2,:,i4)=buf
     end do
   end do
 end do
write(0,*) "SUM",sum(cbuf),sum(m)
 deallocate(buf); allocate(buf(n4))
  do i3=1,n3
    do i2=1,n2
      do i1=1,n1
        buf=cbuf(i1,i2,i3,:)
	call ftu(.true.,buf)
        cbuf(i1,i2,i3,:)=buf
     end do
   end do
 end do
write(0,*) "SUM",sum(cbuf),sum(m)
out=real(cbuf)





end if

ierr=srite("out",out,size(out)*4)


end program



















