module deriv2ax_mod
use adj_mod
implicit none
integer,private :: n(4   )
real,private :: eps

contains

subroutine deriv_ax2_init(n_,rat)
 integer :: n_(4)
 real :: rat
 n=n_
eps=rat
end subroutine

integer function deriv_ax2_op(adj,add,model,data)
 logical,intent(in) :: adj,add
 real :: model(:),data(:)

  call adjnull(adj,add,model,data)
  call deriv(adj,model,data)
   deriv_ax2_op=0
end function
 
subroutine deriv(adj,model,data)
 logical,intent(in) :: adj
 real,dimension(n(1),n(2),n(3),n(4)) :: model,data
 integer i1,i2,i3,i4

  if(.not. adj) then
    do i4=1,n(4)
      do i3=1,n(3)
       do i1=1,n(1)
         data(i1,1,i3,i4)=data(i1,1,i3,i4)+eps*(model(i1,2,i3,i4)-model(i1,1,i3,i4))
         do i2=2,n(2)
           data(i1,i2,i3,i4)=data(i1,i2,i3,i4)+eps*(model(i1,i2,i3,i4)-model(i1,i2-1,i3,i4))
         end do
       end do
     end do
   end do
 else
    do i4=1,n(4)
      do i3=1,n(3)
       do i1=1,n(1)
         model(i1,1,i3,i4)=model(i1,1,i3,i4)-data(i1,1,i3,i4)*eps
         model(i1,2,i3,i4)=model(i1,2,i3,i4)+data(i1,1,i3,i4)*eps
         do i2=2,n(2)
           model(i1,i2,i3,i4)=model(i1,i2,i3,i4)+data(i1,i2,i3,i4)*eps
           model(i1,i2-1,i3,i4)=model(i1,i2-1,i3,i4)-data(i1,i2,i3,i4)*eps
         end do
       end do
     end do
   end do
end if
  

end subroutine


end module



