module hyperbolic_mod
use adj_mod
implicit none
integer,private :: nz,nang,nmov
real,private    :: oang,dang,omov,dmov,oz,dz



contains
subroutine hyperbolic_init(nz_,oz_,dz_,nang_,oang_,dang_,nmov_,omov_,dmov_)
  integer :: nz_,nang_,nmov_
  real    :: omov_,oz_,oang_,dang_,dz_,dmov_

  nz=nz_; nmov=nmov_; nang=nang_
  oz=oz_; omov=omov_; oang=oang_
  dz=dz_; dmov=dmov_; dang=dang_
end subroutine

integer function  hyperbolic_op(adj,add,model,data)
  logical,intent(in)  :: adj,add
  real   :: model(:),data(:)
  call adjnull(adj,add,model,data)
  call hyperbolic_2d(adj,nz,nang,nmov,model,data)
  hyperbolic_op=0
end function

subroutine hyperbolic_2d(adj,nz,nang,nmov,model,data)
  logical,intent(in) :: adj
  real    :: model(nz,nmov),data(nz,nang)
  integer :: fz,fa,fo
  real    :: mz,ma,mo,mov,z,ang
  integer  :: iz,iang,imov,nang,nmov,nz

!dmov=0
!omov=0
  do imov=1,nmov
    mov=omov+dmov*imov
    do iang=1,nang
      ang=oang+dang*iang
      do iz=1,nz
        z=oz+dz*iz
        mz=(sqrt(z*z+mov*ang*ang)-oz)/dz+.5
        fz=mz; !mz=mz-fz
        if(fz >0 .and. fz < nz) then
           if(.not. adj) then
              data(fz,iang)=data(fz,iang)+model(iz,imov)
           else 
 model(iz,imov)=model(iz,imov)+data(fz,iang)
           end if 
         end if
      end do
    end do
  end do
end subroutine







end module


