module istc_solver_mod
  use chain_mod
  use sep_mod
  use arnoldi_mod
  use llist_mod
  use ddot_mod
  use quantile_mod
  use sep

  implicit none
  logical, parameter, private  :: T = .true., F = .false.

contains


  subroutine istc_solver (oper, x, dat, nliter,niter,region,start, &
       x0,verb) 
    optional :: &
       x0,verb
    interface

       function oper (adj, add, x, dat) result (stat)
         integer              :: stat
         logical, intent (in) :: adj, add
         real, dimension (:)  :: x, dat
       end function oper
       function cut_func(iter,val) result (stat)
         integer :: stat,iter,niter
         real :: val(:)
      end function

    end interface
    integer, intent(in) :: niter,nliter,region(:)
    real,    dimension (:),   intent (in)  :: dat,x0,start
    real,    dimension (:),   intent (out) :: x
    integer,dimension(:),allocatable :: reg(:)
    real, dimension(:),allocatable  :: g,gg,rr,tmp
    real,dimension(:,:) ,allocatable :: tau
    integer :: ierr,jsamp,i,initer,iter,nkill,ncount,j
    real :: max_v,sc,val,rat,old,new
    logical :: verb
   

if(present(x0)) then
  x=x0
else
  call random_number(x)
end if
allocate(reg(size(start)))
!
!Begin by figuring out cooling method
!
allocate(tau(maxval(region),nliter),gg(size(dat)),g(size(x)),rr(size(dat)))
!First run forward and ajoint
call random_number(g)

do i=1,20
  ierr=oper(F,F,x,gg)
  ierr=oper(T,F,g,gg)
  sc=sqrt(ddot(g,g))
  g=g/sc
  if(verb) write(0,*) "CHECK THIS",i,sc,ddot(g,g)
  x=g
end do
write(0,*) "DFDFD"
if(present(x0)) then
  x=x0
else
 x=0
end if
!sc=100
sc=sc
sc=1./sc
write(0,*) "MM",size(tau)


tau(:,size(tau,2))=0
write(0,*) "DFDFSDF"
ierr=oper(T,F,g,dat)
write(0,*) "GVFGB"
rat=10000./ddot(dat,dat)
g=abs(g)*sc
write(0,*) "DYING SOME1"
if(start(1)<0.)  then
  val=.005
  allocate(tmp(size(g)))
tmp=abs(g)
write(0,*) "MIN MAX",minval(tmp),maxval(tmp)
do i=1,size(tau,2)-1
    tau(:,i)=quantile(floor((1.-val)*size(tmp)),tmp)
  write(0,*) "CHECK QUANTILE",size(tmp),val,nint((1.-val)*size(tmp)),tau(:,i)

    val=val*1.8
  end do
    deallocate(tmp)

else

do j=1,size(start)
 ncount=0
 val=start(j)/100.
 write(0,*) "DYING 2"
 do i=1,size(g)
   if(region(i)==j) ncount=ncount+1
 end do
 write(0,*) "DYING 3"
 allocate(tmp(ncount))
 write(0,*) "FOUND",j,ncount
 ncount=0
 do i=1,size(g)
   if(region(i)==j) then 
     ncount=ncount+1
     tmp(ncount)=g(i)
   end if
 end do
 do i=1,size(tau,2)-1
   tau(j,i)=quantile(floor((1.-val)*size(tmp)),tmp)
    val=min(val*1.8,.99999)
    if(verb) write(0,*) j,i,val,tau(j,i)
 end do
 deallocate(tmp)
end do
end if



!Loop over cooling steps
do initer=1,nliter
    if(verb) write(0,*) initer," threshold=",tau(:,initer)
    
    !Power method
    iter=1
    old=1000000
    new=999995
    do while(iter <=niter  .and. (old-new >.05) .and. new >.99)
      old=new
      ierr=oper(F,F,x,gg)
      gg=dat-gg*sc  !current residual
      ierr=oper(T,F,g,gg)
      new=ddot(gg,gg)*rat
      g=x+g*sc 
      nkill=0
      do i=1,size(x)
        if(abs(g(i))>tau(region(i),initer)) then
           x(i)=g(i)
        else
           nkill=nkill+1
           x(i)=0
        end if
      end do
      if(verb) write(0,*) iter, " magnitude",new,real(nkill)/real(size(x)),(old-new)/10.

      iter=iter+1
    end do

end do
    deallocate(tau,gg,g,rr)
   
  end subroutine istc_solver

  



end module











