program ab
use sep_mod
use weight
use pursuit_mod
use wavelet_chain_mod
use solver_smp_nrm_mod
use solver_reg_nrm_mod
use levels_mod
use dottest
use hyperbolic_mod
use istc_solver_mod
use slant_mod
use solver_mod
use cgstep_mod
use quantile_mod
use offset_angle_mod
use perc_mod
implicit none
integer :: n1,n2,n3,nang,nz,nmov,j,ierr,i
integer :: i1,i2,i3,nc,n4,i4,count,func(1000,400),nsect,niter_stomp,niter_lin
integer,allocatable :: myc(:),level(:)
integer :: jstack,nstack
real :: zero,rnd(3),oz,dz,oang,dang,ooff,doff,dmov,omov,sm
real :: rgh0(9),sm0(7),err,cut,amax,eps
logical,pointer :: msk2(:)
logical :: do_cone,do_level
!real :: rgh0(4),sm0(4)
real :: dot1(2),dot2(2),pct,val,ff(1000,400),ff2(72,400),pow(400)
real :: mymax,mysq,ww,stt(10000)
logical, pointer :: msk(:)
real, pointer :: dm(:),offd(:),angd(:),lvls(:),start(:)
real,pointer :: in(:,:,:,:),out(:,:,:,:),dat(:),waved(:),junk(:,:),dd(:),wet(:),m0(:),ma(:),wt2(:),dco(:)
character(len=12) :: nn
 double precision  :: sqrt_3 = sqrt( 3. );
     double precision  :: denom = 4 * sqrt( 2. );
  real :: tol,delta,gamma,dg,pi,di,mu
 integer :: iterlp,itercg
nn="l2"

call sep_init()

call from_history("n1",n1)
call from_history("n2",n2)
call from_history("n3",n3)
call from_history("n4",n4)
call from_param("pct",pct)
!sm0=(/1.+sqrt_3,3+sqrt_3,3.-sqrt_3,1.-sqrt_3/)/denom
!rgh0(1)=sm0(4); rgh0(2)=-sm0(3); rgh0(3)=sm0(2); rgh0(4)=-sm0(1)
rgh0=(/.037828,-.023849,-.110624,.377402,.852699,.377402,-.110624,-.023849,.037828/)
sm0=(/-.064539,-.040689,.418092,.788486,.418092,-.040689,-.064539/)

call init_wavelet_transform(sm0,rgh0,n1,n2,n3,n4,4,2,1,1)
!call dot_test(wavelet_transform_op,n1*n2*n3*n4,n1*n2*n3*n4,dot1,dot2)
allocate(dat(n1*n2*n3*n4),waved(n1*n2*n3*n4),wet(n1*n2*n3*n4),dco(n1*n2*n3*n4))
allocate(lvls(n1*n2*n3*n4))

ierr= sreed("in",dat,size(dat)*4)
allocate(m0(size(dat)),ma(size(dat)),dd(size(dat)))
allocate(dm(size(dat)))
m0=dat
dd=dat

!ierr= srite("out",dat,size(dat)*4)
call from_history("n1",nz)
call from_history("d1",dz)
call from_history("o1",oz)
call from_param("nang",nang,n2)
call from_param("oang",oang,0.)
call from_param("dang",dang,.6)
call from_param("nmov",nmov,n2)
call from_param("omov",omov,-3200.)
call from_param("dmov",dmov,100.)
call from_history("d2",doff)
call from_history("o2",ooff)
call from_param("nsect",nsect,30)
call slant_init(nz,oz,dz,nang,oang,dang,n2,ooff,doff)

!i1=unslant_stack(.true.,.false.,m0,dat)
!ierr= srite("out",m0,size(dat)*4)
call set_direction(.true.)
i1=wavelet_transform_op(.true.,.false.,waved,m0)
call to_history("n1",n1,"wavelet")
call to_history("n2",n2,"wavelet")
call to_history("n3",n3,"wavelet")
call to_history("n4",n4,"wavelet")
ierr= srite("out",waved,size(waved)*4)

allocate(level(n1*n2*n3*n4))
call perc_it(8.,(/n1,n2,n3,n4/),(/4,2,1,1/),lvls,level,stt)
allocate(start(maxval(level)))
start=.3*stt(1:size(start))**.33


call from_param("do_cone",do_cone,.true.)
call from_param("do_level",do_level,.true.)




do i1=1,400
  pow(i1)=1+real(401-i1)/80
end do


waved=dat
dat=0
allocate(msk(n1*n2*n3*n4))
write(0,*) "about to randomly sample"
count=0
do i2=1,400
   do i1=1,72
     ff(i1,i2)=max(0.,sin(i1*3.1419526/72.))**pow(i2)
     
 end do
 sm=sum(ff(1:72,i2))
 ff(:,i2)=ff(:,i2)*1000/sm
end do
do i2=1,400
 do i1=2,72
   ff(i1,i2)=ff(i1-1,i2)+ff(i1,i2)
 end do
end do
func=1;
write(0,*) "m,inval",minval(ff),maxval(ff)
do i2=1,400
  mymax=6+30./400.*real(i2)
  mysq=500*500
do i1=1,500
  ww=mymax*real((i1-1)*(i1-1))/mysq
  ff(501-i1,i2)=max(1,nint(real(36.-ww)))
  ff(500+i1,i2)=min(72,nint(real(37.+ww)))
end do
end do
do i1=1,1000
end do
ierr=srite("ff.H",ff,size(ff)*4)
write(0,*) "DONE"

msk=.false.
!wt=.false.
wet=0
call from_param("jstack",jstack,107)
call from_param("nstack",nstack,10)
call semirandom_init(jstack,17,nstack)

ierr=semirandom_op(.false.,.false.,m0,waved)
waved=m0
ierr=0
do while (count < pct/100.*n1*n2*n3*n4)
  ierr=ierr+1
  call random_number(rnd)
  i3=max(1,min(n3*n4,nint(rnd(1)*n3*n4)))  !choose gather
  i1=max(1,min(n1,nint(rnd(2)*n1)))
!  write(0,*) "HUGH",nint(rnd(3)*1000.)
  if(do_cone) then
  i2=max(1,min(1000,nint(rnd(3)*1000.)))
  i2=ff(i2,i1)
  else
    i2=max(1,min(n2,nint(rnd(3)*n2)))
  end if
  i4=i1+(i2-1)*n1+(i3-1)*n1*n2
!  write(0,*) "CHECK IT",i1,i2,i3,i4,size(dat)
  if(.not. msk(i4)) then
     msk(i4)=.true.
     wet(i4)=1.
     count=count+1
     dat(i4)=waved(i4)
  end if
!  if(mod(j,100000)==0) write(0,*) "found",j,count,pct/100.*n1*n2*n3*n4,pct
end do

write(0,*) "BEFORE SRITE"
ierr= srite("map.H",wet,size(dat)*4)
write(0,*) "AFTER SRITE"
call from_param("eps",eps,1e-10)
call from_param("amax",amax,60.)
call init_angle((/n1,n2,n3,n3/),(/oz,ooff,0.,0./),(/dz,doff,1.,1./),amax,eps,.false.)
ierr=srite("wet.H",wet,size(wet)*4);
!dat=waved
!wet=1

!dat=waved
allocate(offd(size(waved)),angd(size(waved)))



write(0,*) "I DIEE 2"
!ierr= srite("out",dat,size(waved)*4)
call wave_chain(size(waved))
write(0,*) "I DIEE22"
call mask1_init(msk)
ierr=srite("out",m0,size(m0)*4)
ierr= srite("out",waved,size(waved)*4)
write(0,*) "I DIEE12"
ierr= srite("out",dat,size(dat)*4)

waved=0.

dd=dat
offd=dat
!TEST INVERT
write(0,*) "I DIEE42"
 call set_direction(.true.)


write(0,*) "I DIEE52"

call weight_init(wet)


!call dot_test(stomp_oper,size(waved),size(waved),dot1,dot2)
!



!≥call dot_test(stomp_it,size(waved),size(waved),dot1,dot2)
!call dot_test(wavelet_transform_op,size(waved),size(waved),dot1,dot2)
!call dot_test(offset_op,size(waved),size(waved),dot1,dot2)
call set_direction(.false.)
call from_param("niter_stomp",niter_stomp,5)
call from_param("niter_lin",niter_lin,40)
write(0,*) "I DIEE62"
allocate(wt2(size(waved)))
write(0,*) "I DIEE72"
!ierr=sreed("wts.HH",wt2,size(wt2)*4)
write(0,*) "I DIEE72"
write(0,*) "CHECK PCT",pct,n1,n2,n3,n4,n1*n2*n3*n4,size(waved)
!msk=.false.
m0=0

allocate(myc(10))
myc(1:2)=4
myc(3:5)=3
myc(6:7)=2
myc(8)=1
myc(9:10)=0
call init_levels((/n1,n2,n3,n4/),(/4,2,1,1/),myc)


if(1==1) then
write(0,*) "STOMP 1"
!call dot_test(stomp_it,size(waved),size(waved),dot1,dot2)
!call dot_test(wavelet_transform_op,size(waved),size(waved),dot1,dot2)
!write(0,*) "IOT"
if(.not. do_level) start=-1
call istc_solver(stomp_it,waved,dat,10,250,level,start,verb=.true.)

ierr=srite("out",waved,size(waved)*4)
ierr=wavelet_transform_op(.false.,.false.,waved,dat)
ierr=srite("out",dat,size(dat)*4)
end if

if(1==3) then
do i=1,niter_stomp
   count=0
   !First map into model space
   ierr=stomp_back(.true.,.false.,waved,dd)
   
ierr=srite("out",dd,size(dd)*4)
ierr=srite("out",waved,size(dd)*4)
   
   !now find hard cuttoff 
   ma=wt2*abs(waved)
   ierr = size(waved)*(1.-.7*pct/100./(1.*niter_stomp))
   cut=quantile(ierr,ma)
   m0=0
   do j=1,size(ma)
     if(abs(waved(j)*wt2(j)) >= cut) msk(j)=.true.
     if(msk(j)) count=count+1
   end do
     ! write(0,*) "cuttoff",cut,ierr,count,1.2*pct/100.*(1.*i)/(1.*niter_stomp)
 !msk=.true.
  call solver(stomp_oper,cgstep,waved,dat,niter_lin,verb=.true.,wt=wet,x0=m0)
 m0=waved
   count=0
     do j=1,size(ma)
        if(abs(waved(j)>0.0001)) then  
           count=count+1
           if(.not. msk(j)) write(0,*) "illogical ",j
      end if
   end do
   write(0,*) "COUNT TOTAL",count
  ierr=srite("out",waved,size(waved)*4)
  ierr=wavelet_transform_op(.false.,.false.,waved,angd)
  !ierr=offset_op(.false.,.false.,angd,dd)
  ierr=srite("out",angd,size(waved)*4)
!  ierr=srite("out",dd,size(waved)*4)
  ierr=semirandom_op(.false.,.false.,angd,dco)
  dd=dat-dco*wet
    ierr=srite("out",dd,size(waved)*4)

end do

end if

end program
