module slant_mod
use adj_mod
implicit none
integer,private :: nz,nang,noff
real,private    :: oang,dang,ooff,doff,oz,dz



contains
subroutine slant_init(nz_,oz_,dz_,nang_,oang_,dang_,noff_,ooff_,doff_)
  integer :: nz_,nang_,noff_
  real    :: ooff_,oz_,oang_,dang_,dz_,doff_

  nz=nz_; noff=noff_; nang=nang_
  oz=oz_; ooff=ooff_; oang=oang_
  dz=dz_; doff=doff_; dang=dang_
   
end subroutine

integer function  unslant_stack(adj,add,model,data)
  logical,intent(in)  :: adj,add
  real   :: model(:),data(:)
  integer :: n3,i3,nb,nd
  call adjnull(adj,add,model,data)
  n3=size(data)/nz/noff
  nd=0
  nb=nz*noff
  do i3=1,n3
    call slant_2d(adj,nz,nang,noff,model(nd+1:nb+nb),data(nd+1:nb+nd))
    nd=nd+nb
  end do
  unslant_stack=0
end function

subroutine slant_2d(adj,nz,nang,noff,model,data)
  logical,intent(in) :: adj
  integer :: nz,nang,noff
  real    :: model(nz,nang),data(nz,noff)
  integer :: fz,fa,fo
  real    :: mz,ma,mo,ang,off
  integer  :: iz,iang,ioff
!$OMP PARALLEL DO default(shared) private(iang,ioff,iz,off,mz,fz)
  do iang=1,nang
    ang=(oang+dang*iang)/45.*atan(1.)
    do ioff=1,noff
      off=ooff+doff*ioff
      do iz=1,nz
        mz=(tan(ang)*off-oz)/dz+iz
        fz=mz; mz=mz-fz
      ! if(iz==100) write(0,*) "CHKEC",off,ang,iz,fz

        if(fz >0 .and. fz < nz) then
           if(.not. adj) then
              data(iz,ioff)=data(iz,ioff)+(1.-mz)*model(fz,iang)+mz*model(fz+1,iang)
           else 
              model(fz,iang)=model(fz,iang)+data(iz,ioff)*(1.-mz)
              model(fz+1,iang)=model(fz+1,iang)+data(iz,ioff)*mz
           end if 
         end if
      end do
    end do
  end do
!$OMP END PARALLEL DO
end subroutine






end module


