module test_op
 use adj_mod
 real,private,pointer:: afilt_s(:),ffilt_s(:),afilt_r(:),ffilt_r(:)
 real, pointer :: x(:)
 integer, private :: n_a,n_f
 contains
 

 integer function fwt97(adj,add,model,data)
   logical, intent(in) :: adj,add
   real                :: model(:),data(:)
   integer             :: i,n
   real                :: a
   fwt97=0
   call adjnull(adj,add,model,data)
   n=size(model)
   allocate(x(n))
   if(adj) then
     x=data
     a=-1.586134342;
     do i=2,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(n)=x(n)+2*a*x(n-1)

     a=-0.05298011854;
     do i=3,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(1)=x(1)+2*a*x(2)

     a=0.8829110762;
     do i=2,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do

     x(n)=x(n)+2*a*x(n-1)

     a=0.4435068522;
     do i=3,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(1)=x(1)+2*a*x(2)
     a=1/1.149604398;

     do i=1,n
       if(mod(i,2)==1) then
         x(i)=x(i)*a
       else
         x(i)=x(i)/a
       end if
     end do
     model=x+model
   else
     x=model
     a=1/1.149604398;
     do i=1,n
       if(mod(i,2)==1) then
         x(i)=x(i)*a
       else
         x(i)=x(i)/a
       end if
     end do

     a=0.4435068522;
     x(2)=x(2)+2*a*x(1)
     do i=3,n-1,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do

     a=0.8829110762;
     x(n-1)=x(n-1)+2*a*x(n)
     do i=2,n-1,2
       x(i+1)=x(i+1)+a*x(i)
       x(i-1)=x(i-1)+a*x(i)
     end do
     a=-0.05298011854;
     x(2)=x(2)+2*a*x(1)
     do i=3,n-1,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do
     
  
     a=-1.586134342;
     x(n-1)=x(n-1)+2*a*x(n)
     do i=2,n-1,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do
     data=data+x
  end if
  deallocate(x)
end function
 
 integer function iwt97(adj,add,model,data)
   logical, intent(in) :: adj,add
   real                :: model(:),data(:)
   integer             :: i,n
   real                :: a
   iwt97=0
   call adjnull(adj,add,model,data)
   allocate(x(size(data)))
   n=size(data)
   if(.not. adj) then
     x=model
     a=1.149604398;
     do i=1,n
       if(mod(i,2)==1) then
         x(i)=x(i)*a
       else
         x(i)=x(i)/a
       end if
     end do
     a=-0.4435068522;
     do i=3,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do

     x(1)=x(1)+2*a*x(2)

     a=-0.8829110762;
     do i=2,n-1,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(n)=x(n)+2*a*x(n-1)

     a=0.05298011854;
     do i=3,n,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(1)=x(1)+2*a*x(2)

     a=1.586134342;
     do i=2,n-3,2
       x(i)=x(i)+a*(x(i-1)+x(i+1))
     end do
     x(n)=x(n)+2*a*x(n-1)
     data=data+x
   else
     x=data
     a=1.586134342;
     x(n-1)=x(n-1)+2*a*x(n)
     do i=2,n-3,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do

     a=0.05298011854;
     x(2)=x(2)+2*a*x(1)
     do i=3,n,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do

     a=-0.8829110762;
     x(n-1)=x(n-1)+2*a*x(n)
     do i=2,n-1,2
       x(i-1)=x(i-1)+a*x(i)
       x(i+1)=x(i+1)+a*x(i)
     end do

     a=-0.4435068522;
     x(2)=x(2)+x(1)*2*a
     do i=3,n-1,2
       x(i+1)=x(i+1)+a*x(i)
       x(i-1)=x(i-1)+a*x(i)
     end do
     a=1.149604398;
     do i=1,n
       if(mod(i,2)==1) then
         x(i)=x(i)*a
       else
         x(i)=x(i)/a
       end if
     end do
     model=model+x
   end if
 end function

 subroutine init_test(a_filt,f_filt)
  real :: f_filt(:),a_filt(:)
  integer :: i
  allocate(afilt_s(size(a_filt)),afilt_r(size(a_filt)))
  allocate(ffilt_s(size(f_filt)),ffilt_r(size(f_filt)))
  n_a=(size(a_filt)-1)/2
  n_f=(size(f_filt)-1)/2
  do i=1,size(a_filt)
     afilt_s(i)=a_filt(i)
     afilt_r(i)=a_filt(i)*(-1)**(i+1)
  end do

    do i=1,size(f_filt)
     ffilt_s(i)=f_filt(i)
     ffilt_r(i)=-f_filt(i)*(-1)**(i+1)
  end do
 end subroutine


integer function to_wavelet(adj,add,model,junk)
 logical,intent(in):: adj,add
 real :: model(:),junk(:)
 real, allocatable :: data(:)
 integer :: i1,j,k1,n1,ii
 to_wavelet=0
 
 call filter_it(adj,add,model,junk,n_a,afilt_s,afilt_r)
end function
subroutine filter_it(adj,add,model,junk,n_a,afilt_s,afilt_r)
  logical, intent(in) :: adj,add
  real :: model(:),junk(:)
  real,allocatable :: data(:)
  integer :: i1,j,k1,n1,ii
  integer  :: n_a
  real :: afilt_s(:),afilt_r(:)
  
n1=size(junk)
 allocate(data(-n_a+1:n1+n_a))
 call adjnull(adj,add,model,junk)
 if(.not. adj) then
data=0
j=1
k1=n1/2
do i1=1,n1/2
  j=(i1-1)*2+1
  k1=i1+n1/2
  do ii=-n_a,n_a
    data(j+ii)=data(j+ii)+afilt_r(ii+n_a+1)*model(k1)+model(i1)*afilt_s(ii+n_a+1)
  end do
end do
junk(1:n1)=junk(1:n1)+data(1:n1)
junk(n1-n_a+1:n1)=junk(n1-n_a+1:n1)+data(-n_a+1:0)
junk(1:n_a)=junk(1:n_a)+data(n1+1:n1+n_a)
 else
   data(1:n1)=junk(1:n1)
   data(-n_a+1:0)=junk(n1-n_a+1:n1)
   data(n1+1:n_a+n1)=junk(1:n_a)
   j=1
do i1=1,n1/2
  j=(i1-1)*2+1
  model(i1+n1/2)=model(i1+n1/2)+sum(afilt_r*data(j-n_a:j+n_a))
  model(i1)=model(i1)+sum(afilt_s*data(j-n_a:n_a+4))
end do
 end if
 deallocate(data)
end subroutine
integer function from_wavelet(adj,add,model,junk)
 logical,intent(in):: adj,add
 real :: model(:),junk(:)
 real, allocatable :: data(:)
 integer :: i1,j,k1,n1
   from_wavelet=0
   call filter_it(adj,add,model,junk,n_f,ffilt_s,ffilt_r)
end function


end module 
